# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/)
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [v1.0.3](https://github.com/es-shims/Array.prototype.map/compare/v1.0.2...v1.0.3) - 2020-11-19

### Commits

- [Tests] migrate tests to Github Actions [`7f300c8`](https://github.com/es-shims/Array.prototype.map/commit/7f300c8dc386f6452a8a742c3ff1955f79fca448)
- [meta] do not publish github action workflow files [`59276a2`](https://github.com/es-shims/Array.prototype.map/commit/59276a22dbac0a431e422d7056b06a51c565c0ed)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `aud`, `auto-changelog`,  `tape` [`3502b73`](https://github.com/es-shims/Array.prototype.map/commit/3502b73827b0998edd6538ce7728d5fd9933c15f)
- [Deps] update `es-abstract`; use `call-bind` where applicable [`37643d8`](https://github.com/es-shims/Array.prototype.map/commit/37643d8611c54b4b7f159532b4a7ea8fc183cb6b)
- [Tests] run `nyc` on all tests [`78049a0`](https://github.com/es-shims/Array.prototype.map/commit/78049a085944abd2186d9d7fbcf442b19b11d1e7)
- [actions] add "Allow Edits" workflow [`9e486a9`](https://github.com/es-shims/Array.prototype.map/commit/9e486a9865d5874768ed414b1e1cf30ec025fed7)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `functions-have-names`, `tape` [`fef8cac`](https://github.com/es-shims/Array.prototype.map/commit/fef8cac1ed6b3f37fcc8d77e44603d0f885ab4a3)
- [Tests] run `es-shim-api` in postlint; use `tape` runner [`4b26f09`](https://github.com/es-shims/Array.prototype.map/commit/4b26f09fcac54df57fb496ca31f435336e1ef470)
- [Dev Deps] update `auto-changelog`, `tape` [`6d3bb01`](https://github.com/es-shims/Array.prototype.map/commit/6d3bb01f5d092fce194a51d2782133803b8801ee)
- [Deps] update `es-abstract`, `is-string` [`88bce11`](https://github.com/es-shims/Array.prototype.map/commit/88bce1118b8452c9f6c89d68f2f247f1946e89dd)
- [Dev Deps] update `auto-changelog`; add `aud` [`6bfd366`](https://github.com/es-shims/Array.prototype.map/commit/6bfd3666905d45e76a3b988f01720c98619e84a4)
- [actions] switch Automatic Rebase workflow to `pull_request_target` event [`fcdb329`](https://github.com/es-shims/Array.prototype.map/commit/fcdb329c0bb0f23a77c4092dbdbed0e1073b4582)
- [Deps] update `es-abstract` [`9ddb318`](https://github.com/es-shims/Array.prototype.map/commit/9ddb31815b8254a2d1f2fc1e9b37da9b42ed979e)
- [Tests] only audit prod deps [`61176f9`](https://github.com/es-shims/Array.prototype.map/commit/61176f995d0c58348a95f04b8b15aa51ba21711f)

## [v1.0.2](https://github.com/es-shims/Array.prototype.map/compare/v1.0.1...v1.0.2) - 2019-12-16

### Commits

- [Refactor] use split-up `es-abstract` (66% bundle size decrease) [`d1bf408`](https://github.com/es-shims/Array.prototype.map/commit/d1bf408f70ef059bcb8beb28f960073ed4792c23)
- [Dev Deps] update `eslint` [`7c6f449`](https://github.com/es-shims/Array.prototype.map/commit/7c6f449e1b0ec6a7b0c04b1952a6a16d145fa2a1)

## [v1.0.1](https://github.com/es-shims/Array.prototype.map/compare/v1.0.0...v1.0.1) - 2019-11-21

### Commits

- [Tests] use shared travis-ci configs [`a3c7bac`](https://github.com/es-shims/Array.prototype.map/commit/a3c7bac90d35642d683ad7704be4c4bf639ae0ee)
- [meta] add `auto-changelog` [`9101d3a`](https://github.com/es-shims/Array.prototype.map/commit/9101d3a09cc6bb3fd814439ea81664cdf436d75a)
- [actions] add automatic rebasing / merge commit blocking [`5183622`](https://github.com/es-shims/Array.prototype.map/commit/5183622f5819712275e1fbdb16c27c4aae35b3c1)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `safe-publish-latest`, `functions-have-names`, `auto-changelog` [`8bdd590`](https://github.com/es-shims/Array.prototype.map/commit/8bdd5904e505a96f7cfa34cf15618a4b551e9b29)
- [Fix] [Refactor]: move `is-string` to prod deps; use callBound instead of `function-bind` [`f0a4b33`](https://github.com/es-shims/Array.prototype.map/commit/f0a4b33df2268f2e7bdc3f777e0c1d3d85f99a90)
- [readme] fix example [`0fbd655`](https://github.com/es-shims/Array.prototype.map/commit/0fbd655b90b4d7791bd26da4322370230e40aca2)
- [Deps] update `es-abstract` [`9f9a70e`](https://github.com/es-shims/Array.prototype.map/commit/9f9a70ea4666dc644adcd126982bf9095747039a)
- [meta] add `funding` field [`b944c33`](https://github.com/es-shims/Array.prototype.map/commit/b944c3304e142053c6aa34ab69b4fc551e89eb4d)
- [Dev Deps] update `@ljharb/eslint-config` [`9b6d8e3`](https://github.com/es-shims/Array.prototype.map/commit/9b6d8e3390bcf989d940e187eba59f6077d02a7e)
- [actions] fix name of this action [`511a82f`](https://github.com/es-shims/Array.prototype.map/commit/511a82f57071320bb096923f1bba346d9b1c79f2)

## v1.0.0 - 2019-09-28

### Commits

- Tests [`7c021cb`](https://github.com/es-shims/Array.prototype.map/commit/7c021cb73eb1dc791384a85f17f28d3d0c8034fd)
- [Tests] add `travis.yml` [`7c4a1f6`](https://github.com/es-shims/Array.prototype.map/commit/7c4a1f632034cd552be5e179837aaddc44e425cd)
- implementation [`c5e97f7`](https://github.com/es-shims/Array.prototype.map/commit/c5e97f72e70f04166c1eda8d67e21f8c0d7ec973)
- Initial commit [`f7ddee4`](https://github.com/es-shims/Array.prototype.map/commit/f7ddee424d3ea57ba6a8deef32375a74f88d0977)
- readme [`86dfaa0`](https://github.com/es-shims/Array.prototype.map/commit/86dfaa09fc0aba93f5c80813ad3159f61ce37042)
- [Tests] add `npm run lint` [`1a64f45`](https://github.com/es-shims/Array.prototype.map/commit/1a64f457f6b9693c1b56303ded0f0e64253c9704)
- npm init [`cda5cda`](https://github.com/es-shims/Array.prototype.map/commit/cda5cda6fb2b3cd6107d79c1535ded3e4c9cead3)
- [meta] add `safe-publish-latest`, `auto-changelog` [`645f846`](https://github.com/es-shims/Array.prototype.map/commit/645f8465648969b8c908fad098403f3fc112d0e4)
- Only apps should have lockfiles [`32c5860`](https://github.com/es-shims/Array.prototype.map/commit/32c5860900487e6de237ec184d02639eaeea536d)
